#ifndef CELLLISTDIALOG_H
#define CELLLISTDIALOG_H

#include <QDialog>
#include <QStandardItemModel>

typedef struct {
               float  par[6];     // cell parameters
               float  sd[6];      // st. dev. on parameters
               float  vol;        // cell volume
               float  m20;        // m20
               float  alt_fom;    // alternative f.o.m
               float  mc20;       // f.o.m used in mcmaille
               float  zshift;     // zero shift
               int    nund;       // num. of unindexed lines
               char   sys[3];     // crystal system
               char   syminfo[21];// additional symmetry information
               int    pcode;      // indexing program code
             } cell_info_type;

namespace Ui {
class CellListDialog;
}

class CellListDialog : public QDialog
{
    Q_OBJECT

public:
    explicit CellListDialog(QWidget *parent = nullptr);
    ~CellListDialog();
    void createModel(cell_info_type cell[], int ncell, int selectedCell);
    void waitSignalIsEmitted();
    int selectedCell() const;

private:
    Ui::CellListDialog *ui;
    QStandardItemModel *cellListModel;
};

#endif // CELLLISTDIALOG_H
