#include "minmaxdelegate.h"
#include <QDoubleSpinBox>
//#include <QDebug>

MinMaxDelegate::MinMaxDelegate(QObject *parent) :
    QStyledItemDelegate(parent),
    m_decimals(3),
    mincol(-1),
    maxcol(-1)
{

}

QWidget *MinMaxDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
    Q_UNUSED(option);

    QDoubleSpinBox *editor = new QDoubleSpinBox(parent);
    editor->setDecimals(m_decimals);
    editor->setSingleStep(0.001);

    if (index.column() == mincol){
        QModelIndex indexMax = index.model()->index(index.row(),maxcol,QModelIndex());
        editor->setMinimum(0);
        editor->setMaximum(indexMax.data(Qt::DisplayRole).toDouble());        
    }
    if (index.column() == maxcol){
        QModelIndex indexMin = index.model()->index(index.row(),mincol,QModelIndex());
        editor->setMinimum(indexMin.data(Qt::DisplayRole).toDouble());
    }

    //qDebug() << "Decimals: " << editor->decimals() << "Range: " << editor->minimum() << "-" << editor->maximum();

    return editor;
}

QString MinMaxDelegate::displayText(const QVariant &value, const QLocale &locale) const
{
    return locale.toString(value.toDouble(),'f',m_decimals);
}

void MinMaxDelegate::setDecimals(int decimals)
{
    m_decimals = decimals;
}

void MinMaxDelegate::setMinMaxcol(int min, int max)
{
    mincol = min;
    maxcol = max;
}

