#ifndef MYFILEDIALOG_H
#define MYFILEDIALOG_H

#include <QFileDialog>
#include <QLineEdit>

class MyFileDialog : public QFileDialog
{
    Q_OBJECT
public:
    explicit MyFileDialog(QWidget *parent = nullptr);
    QString getOutputFile() {return outputFile;}

private:
    QLineEdit *outFile;
    QLineEdit *inpFile;
    QPushButton *editButton;
    QString outputFile;

private slots:
    void onEdit();
    void onCurrentChanged(QString current);
    void onTextChanged(QString current);
    void onOutChanged(QString current);

signals:
    void editSelected(QString filename, MyFileDialog *dlg);

public slots:
    void accept();
};

#endif // MYFILEDIALOG_H
