#ifndef NORMHYDRODLG_H
#define NORMHYDRODLG_H

#include <QDialog>
#include <QStandardItem>
#include <QStandardItemModel>
#include <QItemSelectionModel>

static float distH0[] =  { 1.10f,   //CH3 metilico
                           1.10f,   //CH2 metilenico
                           1.10f,   //CH metinico
                           1.08f,   //C_ALCHINO: in alchino terminale
                           1.08f,   //C_Ar: composti aromatici
                           1.08f,   //X=CH2 terminale
                           0.95f,   //distanza O-H
                           1.01f,   //distanza N-H in ammina primaria
                           1.01f,   //distanza N-H in ammina secondaria
                           1.31f,   //distanza S-H
                           1.10f,   //distanza B-H
                           1.10f,   //C_DEF
                           1.01f};  //N_DEF

const static int nDistances = (int) (sizeof(distH0)/sizeof(distH0[0]));

namespace Ui {
class NormHydroDlg;
}

class NormHydroDlg : public QDialog
{
    Q_OBJECT

public:
    explicit NormHydroDlg(QWidget *parent = 0);
    ~NormHydroDlg();
    void setDist(float v[]) {for(int i=0; i<nDistances; i++) Hdist[i]=v[i];}
    void setModel(int k) {kmodel=k;}
    void populateModel();
    float *getDistances();

private:
    Ui::NormHydroDlg *ui;
    QStandardItemModel *mModel;
    float Hdist[nDistances];
    int kmodel;

private slots:
    void on_okButton_clicked();
    void on_applyButton_clicked();
    void on_defaultsButton_clicked();
    void on_cancelButton_clicked();

protected:
    virtual void showEvent(QShowEvent *event);

signals:
    void normHydroDlgClosed(int code, int n);
};

#endif // NORMHYDRODLG_H
