#include "pairdistsettings.h"
#include "ui_pairdistsettings.h"
#include "qt_utils.h"

PairDistSettings::PairDistSettings(QStatusBar *bar, QWidget *parent) :
    QDialog(parent),
    ui(new Ui::PairDistSettings)
{
    ui->setupUi(this);
    mBar = bar;
}

PairDistSettings::~PairDistSettings()
{
    delete ui;
}

void PairDistSettings::FillForm(int wm, pdf_option_type *pdf)
{
    pdfG = pdf;
    m_Model = wm;
    ui->comboWave->setCurrentIndex(pdf->rad);
    ui->spinQmax->setValue(pdf->qmax);
    ui->spinRmax->setValue(pdf->rmax);
}

void PairDistSettings::ReadForm(pdf_option_type *pdf)
{
    pdf->rad = ui->comboWave->currentIndex();
    pdf->qmax = ui->spinQmax->value();
    pdf->rmax = ui->spinRmax->value();
}

void PairDistSettings::on_applyButton_clicked()
{
    ReadForm(pdfG);
    Attesa("Computing PDF. Please wait ...", mBar);
    jav_pdf_(&m_Model, pdfG);
}

void PairDistSettings::on_closeButton_clicked()
{
    destroy();
}

void PairDistSettings::on_okButton_clicked()
{
    ReadForm(pdfG);
    Attesa("Computing PDF. Please wait ...", mBar);
    jav_pdf_(&m_Model, pdfG);
    destroy();
}
