#ifndef POWDERPATTERNSETTINGS_H
#define POWDERPATTERNSETTINGS_H

#include <QDialog>

namespace Ui {
class PowderPatternSettings;
}

typedef struct {
    int     nwave; // = 1
    float   wave[2];
    float   ratio[2];
    float   ttmin;  // = 5
    float   ttmax;  // = 70
    float   ttstep;  // = 0.02
    float   fwhm;  // = 0.1
    float   scal;  // = 1000.
    float   back;  // = 0.0
                 } xpd_option_type;

extern "C" void jav_powder_pattern_(int *km, xpd_option_type *xpd);

class PowderPatternSettings : public QDialog
{
    Q_OBJECT

public:
    explicit PowderPatternSettings(QWidget *parent = 0);
    ~PowderPatternSettings();
    void FillForm(int wm, xpd_option_type *xpd);

private:
    Ui::PowderPatternSettings *ui;
    bool ReadForm(xpd_option_type *xpd);
    int m_Model;
    xpd_option_type *xpdG;

private slots:
    void on_okButton_clicked();
    void on_applyButton_clicked();
    void on_closeButton_clicked();
};

#endif // POWDERPATTERNSETTINGS_H
