MODULE enable_amb

    implicit none

    enum, bind(c)
      enumerator :: STOP_EVENT=1, SKIP_EVENT, CYCLE_EVENT
    endenum

    enum, bind(c)
      enumerator :: InitAction, PatternAction, StructureAction,  &
                    PatternAndStructureAction, DialogOpenAction, &
                    RunAction, RunSkipAction, NextAction,        & 
                    PhaseAction, SaveAction, RestoreAction,      &
                    IntervalsAction, ExtraAction,                &
                    ExtraBackgroundAction, ProfileAction,        & 
                    CycleAction, PeaksAction
    endenum

    interface abilita_tasti
      module procedure abilita_tasti_string, abilita_tasti_int
    end interface
!FIXME-You ended up removing abilita_tasti_string

CONTAINS 

    recursive subroutine abilita_tasti_string(scode,state)
    USE molcom
    character(len=*), intent(in)  :: scode
    integer, intent(in), optional :: state   ! 0=set no sensitive, 1=sensitive, 2=hide
    integer                       :: statet
    interface
       subroutine c_enableActions(kaction, state) bind(C,name="c_enableActions")
       use iso_c_binding
       integer(c_int), intent(in), value :: kaction
       integer(c_int), intent(in), value :: state
       end subroutine c_enableActions
    end interface
!
    if (jscreen  > 0) then
        if (present(state)) then
            statet = state
        else
            statet = 1
        endif
        select case (trim(scode))
            case ('indexwin')
             call wmenu_set_state('File'//char(0),state)
             call tb_set_state('file',state)
             call wmenu_set_state('Solve'//char(0),state)
             call wmenu_set_state('Refine'//char(0),state)
             call wmenu_set_state('Range'//char(0),state)
             call wmenu_set_state('Indexing'//char(0),state)
             call wmenu_set_state('Space Group'//char(0),state)

            case ('pattern')
             call c_enableActions(PatternAction,statet)
!qt             call wmenu_set_state('File'//char(0),1)
!qt             call abilita_tasti('view_pattern')
!qt             call abilita_tasti('peaks',1)
!qt             call abilita_tasti('indexing',1)
!qt             call wmenu_set_state('View'//char(0),1)
!qt             call wmenu_set_state('Info'//char(0),1)
!qt             call tb_set_state('file',1)
!qt             call tb_set_state('procedure',0)
!qt!
!qt!            Only Simulated Annealing and Rietveld are permitted
!qt             call wmenu_set_state('Solve'//char(0),1)
!qt             call wmenu_set_state('RAMM'//char(0),0)
!qt             call wmenu_set_state('Explore trials'//char(0),0)
!qt             call wmenu_set_state('POLPO'//char(0),0)
!qt             call wmenu_set_state('Simulated Annealing + Direct Methods'//char(0),0)
!qt             call wmenu_set_state('Recycle in extra'//char(0),0)
!qt
!qt             call wmenu_set_state('Refine'//char(0),1)
!qt             call wmenu_set_state('Resolution Bias Modification (RBM)'//char(0),0)
!qt             call wmenu_set_state('Fourier Recycling'//char(0),0)
!qt             call wmenu_set_state('Fourier'//char(0),0)
!qt             call wmenu_set_state('Peak labelling'//char(0),0)

            case ('run')
             call c_enableActions(RunAction,statet)
!qt             call abilita_tasti('window')
!qt             call toolbar_set_state('Stop'//char(0),1)
!qt             call toolbar_set_state('pointmode'//char(0),0)

            case ('run+skip')
             call c_enableActions(RunSkipAction,statet)
!qt             call abilita_tasti('window')
!qt             call toolbar_set_state('Stop'//char(0),1)
!qt             call toolbar_set_state('Skip'//char(0),1)
!qt             call toolbar_set_state('pointmode'//char(0),0)

!qt            case ('structure+pattern')
!qt             call c_enableActions(PatternAndStructureAction,statet)
!qt             call abilita_tasti('pattern')   ! abilita tutti i tasti dello spettro
!qt             call abilita_tasti('structure')   
      
            case ('window')
             call wmenu_set_state('File'//char(0),0)
             call abilita_tasti('view_pattern')
             call wmenu_set_state('View'//char(0),1)
             call wmenu_set_state('Solve'//char(0),0)
             call wmenu_set_state('Refine'//char(0),0)
             call wmenu_set_state('Info'//char(0),1)
             call tb_set_state('file',0)
             call toolbar_set_state('display structure'//char(0),1)
             call tb_set_state('procedure',0)

            case ('window_pattern')
             call wmenu_set_state('File'//char(0),0)
             call wmenu_set_state('Pattern'//char(0),0)
             call tb_set_state('pattern',1)
             call wmenu_set_state('Solve'//char(0),0)
             call wmenu_set_state('Refine'//char(0),0)
             call wmenu_set_state('Info'//char(0),1)
             call tb_set_state('file',0)
             call toolbar_set_state('display structure'//char(0),0)
             call tb_set_state('procedure',0)

            case ('peaks')
             if (present(state)) then
                 call toolbar_set_state('pointmode'//char(0),state)
                 call toolbar_set_state('peaksmode'//char(0),state)
                 call wmenu_set_state('Modify Peaks'//char(0),state)
                 call wmenu_set_state('Background'//char(0),state)
             endif

            case ('indexing')
             call wmenu_set_state('Indexing'//char(0),state)

            case ('rietveld')
             call abilita_tasti('window')
             call toolbar_set_state('pointmode'//char(0),1)
             call wmenu_set_state('Background'//char(0),1)

            case ('view_pattern')
             call wmenu_set_state('Pattern'//char(0),1)
             call wmenu_set_state('Range'//char(0),0)
             call wmenu_set_state('Intervals'//char(0),0)
             call wmenu_set_state('Background'//char(0),0)
             !call wmenu_set_state('Options'//char(0),1)
             !call wmenu_set_state('Draw Legend'//char(0),1)
             !call wmenu_set_state('Fonts & Colors'//char(0),1)
             !call wmenu_set_state('Alien Programs'//char(0),1)
             call tb_set_state('pattern',1)

            case ('structure')
             call c_enableActions(StructureAction,statet)
!qt             call wmenu_set_state('Solve'//char(0),statet)
!qt             call wmenu_set_state('Refine'//char(0),statet)
!qt             call wmenu_set_state('Resolution Bias Modification (RBM)'//char(0),statet)
!qt             call toolbar_set_state('display structure'//char(0),statet)

            case default
             write(0,*)'CODE NOT FOUND '//trim(scode)

        end select
    endif
!
    end subroutine abilita_tasti_string

!---------------------------------------------------------------------------------

    subroutine abilita_tasti_int(kaction,state)
    USE molcom
    integer, intent(in)  :: kaction
    integer, intent(in), optional :: state   ! 0=set no sensitive, 1=sensitive, 2=hide
    integer                       :: statet
    interface
       subroutine c_enableActions(kaction, state) bind(C,name="c_enableActions")
       use iso_c_binding
       integer(c_int), intent(in), value :: kaction
       integer(c_int), intent(in), value :: state
       end subroutine c_enableActions
    end interface
!
    if (jscreen  > 0) then
        if (present(state)) then
            statet = state
        else
            statet = 1
        endif

        call c_enableActions(kaction,statet)
    endif

    end subroutine abilita_tasti_int
 
!---------------------------------------------------------------------------------
!qt
!qt     subroutine abilita_tasti2()
!qt     use variables
!qt     use datasetmod
!qt     logical :: powder, structure
!qt
!qt     powder = .false.
!qt     structure = .false.
!qt     if (ndataset(dataset) > 0) then
!qt         powder = dataset(1)%npoints() > 0 .and. dataset(1)%datatype == POW_DATA
!qt     endif
!qt     structure = cryst(1)%natoms() > 0
!qt      
!qt     if (structure .and. powder) then
!qt         call abilita_tasti(PatternAndStructureAction)
!qt         return
!qt     endif
!qt     if (structure) then
!qt         call abilita_tasti(StructureAction)
!qt         return
!qt     endif
!qt     if (powder) call abilita_tasti(PatternAction)
!qt
!qt     end subroutine abilita_tasti2
!qt
!---------------------------------------------------------------------------------

    subroutine tb_set_state(string,state)
    character(len=*), intent(in) :: string
    integer, intent(in)          :: state
!
    select case(string)
        case ('file')
             call toolbar_set_state('Quit'//char(0),state)
             call toolbar_set_state('New Project'//char(0),state)
             call toolbar_set_state('Load'//char(0),state)
             call toolbar_set_state('Old project'//char(0),state)

        case ('pattern')
             call toolbar_set_state('selectionmode'//char(0),state)
             call toolbar_set_state('zoommode'//char(0),state)
             call toolbar_set_state('NoArea'//char(0),state)
             call toolbar_set_state('Reset View'//char(0),state)
             call toolbar_set_state('Zoom_left'//char(0),state)
             call toolbar_set_state('Zoom_right'//char(0),state)
             call toolbar_set_state('legendTog'//char(0),state)

        case ('procedure')
             call toolbar_set_state('Stop'//char(0),state)
             call toolbar_set_state('Skip'//char(0),state)

    end select
!
    end subroutine tb_set_state

!----------------------------------------------------------------------------------------------------

   integer function event_from_gui() result(event)
   USE Molcom, only: jscreen, ifBrekke
!
   if (jscreen > 0 .and. ifBrekke /= 0) then
       select case (ifBrekke)
          case (SKIP_EVENT)  
            event = ifBrekke
          case (STOP_EVENT) 
            event = ifBrekke
          case (CYCLE_EVENT)
            event = 1
          case default
            event = 0
       end select
       ifBrekke = 0
   else
       event = 0
   endif
!
   end  function event_from_gui

END MODULE enable_amb
