#ifndef SPHEREDIALOG_H
#define SPHEREDIALOG_H

#include <QDialog>
#include <QStandardItemModel>
#include <QItemSelection>
#include <QVector>

namespace Ui {
class SphereDialog;
}

class SphereDialog : public QDialog
{
    Q_OBJECT

public:
    explicit SphereDialog(QWidget *parent = 0);
    ~SphereDialog();
    void SetCentre(QString lab_atom);
    void SetRadius(float val);
    int getModel() {return kmodel;}
    void setModel(int n) {kmodel=n;}
    void fillList(QList<QStandardItem *> *items, int nitems);

private:
    Ui::SphereDialog *ui;
    int kmodel;
    QStandardItemModel *sphereList;
    QStandardItemModel *CreaLista(QStringList headers);
    void rowSelectionChanged(const QItemSelection &, const QItemSelection &);

private slots:
    void on_spinRadius_valueChanged(double val);
    void on_centre_editingFinished();
    void reject() override;

signals:
    void selectedCentre(QString lab);
    void selectedRadius(float rad);
    void sphereSelectionChanged(QVector<int> v);
};
#endif // SPHEREDIALOG_H
