#ifndef TEXTEDITOR_H
#define TEXTEDITOR_H

#include <QDialog>
#include <QTextStream>
#include <QWidget>
#include <QPrinter>
#include <QPrintDialog>
#include <QLineEdit>
#include <QTextEdit>

namespace Ui {
class TextEditor;
}

class TextEditor : public QDialog
{
    Q_OBJECT

public:
    explicit TextEditor(QWidget *parent = nullptr);
    ~TextEditor();
    void LoadFile(QString filename);
    void LoadFromString(QString &str);
    void SetEditable(bool editable);
    void SetSave(bool saveas) {mSaveAs = saveas; }    
    QTextEdit *getTextEdit();

private:
    Ui::TextEditor *ui;
    QString mFilename;
    bool mSaveAs;

private slots:
    void on_actionExit_triggered();
    void on_actionSave_triggered();
    void on_actionPrint_triggered();
    void on_actionFont_triggered();
    void on_actionFind();
};

#endif // TEXTEDITOR_H
