#ifndef TRANSFORMDIALOG_H
#define TRANSFORMDIALOG_H

#include <QDialog>
#include <QStandardItemModel>
#include <QStandardItem>
#include <QItemSelection>

namespace Ui {
class TransformDialog;
}

class TransformDialog : public QDialog
{
    Q_OBJECT

public:
    explicit TransformDialog(QWidget *parent = 0);
    ~TransformDialog();
    void Fill(std::vector<int> atoms_sel, int whichModel);

signals:
    void trasformDlgClosed();

private:
    Ui::TransformDialog *ui;
    QStandardItemModel *transformModel;
    int kmodel;
    std::vector<int> atomsSel;
    QString noBlank(QString str);
    bool getMatrices(QString input, int RMatrix[3][3], float TMatrix[3]);
    void fillMatrices(int RMatrix[3][3], float TMatrix[3]);
    void doTransform(int param);

private slots:
    void rowSelectionChanged(const QModelIndex &current, const QModelIndex &);
    void on_transformButton_clicked();
    void on_copyButton_clicked();
    void on_cancelButton_clicked();

protected:
    virtual void showEvent(QShowEvent *event);
};

#endif // TRANSFORMDIALOG_H
